/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "common.h" 
#include <string.h>

#include <artnet/artnet.h> 
#include <artnet/packets.h>

#include <stdio.h>


void sd_event(gpointer data, gint source,  GdkInputCondition con) {
	artnet_node n = (artnet_node) data; 
	
	artnet_read(n,0) ;
}



int
main (int argc, char *argv[]) {
  GtkWidget *window1;
  GtkListStore *listStore ; 
  GtkTreeIter iter ;
  GtkTreeView *treeView ;
  GtkCellRenderer     *renderer;
  GtkLabel *label ;
  gchar *gstr ;
	
  int i, t ;
	
#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  
  /**
   * Set up the tree models for the four ports
   *
   */   
  for(t=0; t< ARTNET_MAX_PORTS; t++) {
	gstr = g_strdup_printf("recv_treeview%i", t+1) ;
    treeView = (GtkTreeView*) lookup_widget(window1, gstr) ;
    listStore = gtk_list_store_new(NUMB_COLS,G_TYPE_INT,G_TYPE_UCHAR) ;
  
    renderer = gtk_cell_renderer_text_new ();
    gtk_tree_view_insert_column_with_attributes (treeView,
                                               -1,      
                                               "Chan",  
                                               renderer,
                                               "text", COLUMN_CHANNEL,
                                               NULL);
	renderer = gtk_cell_renderer_text_new ();
											   
    gtk_tree_view_insert_column_with_attributes (treeView,
                                               -1,      
                                               "Data",  
                                               renderer,
                                               "text", COLUMN_DATA,
                                               NULL);
											   
    for(i=0; i< ARTNET_MAX_DMX; i++) {
	  gtk_list_store_append(listStore, &iter) ;
	  gtk_list_store_set(listStore, &iter, COLUMN_CHANNEL, i+1, COLUMN_DATA, 0, -1 );
    }

    gtk_tree_view_set_model(treeView, (GtkTreeModel*) listStore) ;
  }
  
  gtk_widget_show (window1);

  // reset generated data
  memset(&output_data[0], 0x00, ARTNET_MAX_PORTS * ARTNET_MAX_DMX) ;
  
  // set up the artnet_node
 // we need a window here to select interfaces
// this is really dodgy  
  if(argc >1) {
	    node = artnet_new(argv[1], 0) ;
  } else {
	    node = artnet_new(NULL, 0) ; ;
  }

  active_node = NULL ;
  nodes_found = 0;
	
  artnet_set_short_name(node, "This is a test wit") ;
  artnet_set_long_name(node, "This is a test with long node name, more than 18 chars") ;
  artnet_set_node_type(node, ARTNET_SRV) ;

  artnet_set_handler(node,ARTNET_RECV_HANDLER, on_packet_recv, window1) ;
  artnet_set_handler(node,ARTNET_SEND_HANDLER, on_packet_send, window1) ;	
  artnet_set_handler(node,ARTNET_POLL_HANDLER, on_poll_recv, window1) ;
  artnet_set_handler(node,ARTNET_REPLY_HANDLER, on_reply_recv, window1) ;
    artnet_set_handler(node,ARTNET_TOD_REQUEST_HANDLER, on_tod_request_recv, window1) ;
  artnet_set_dmx_handler(node, on_dmx_recv, window1) ;
	
  artnet_set_subnet_addr(node, 0) ;

  for(i=0; i < ARTNET_MAX_PORTS; i++) {
  	artnet_set_port_type(node, i, ARTNET_ENABLE_INPUT | ARTNET_ENABLE_OUTPUT, ARTNET_PORT_DMX) ;

  	artnet_set_port_addr(node, i, ARTNET_INPUT_PORT, i) ;
  	artnet_set_port_addr(node, i, ARTNET_OUTPUT_PORT, i) ;
  }
  
  artnet_start(node) ;
  	
  gstr = g_strdup_printf("%i", TICKS_PER_SECOND) ;
  label = (GtkLabel*) lookup_widget(window1, "ticks_label") ;
  gtk_label_set_text(label, gstr) ;
  
  gdk_input_add( artnet_get_sd(node) , GDK_INPUT_READ,sd_event, (gpointer)node );
  
  gtk_main ();
  return 0;
}
